﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class myaccount_modules_edit_video_info : System.Web.UI.UserControl
{
    private long _videoid = 0;
    private string _username = "";
    private string _title = "";
    private string _description = "";
    private string _tags = "";
    private int _categoryid = 0;
    private int _isprivate = 0;
    private int _iscomments = 0;
    private int _isresponse = 0;
    private int _isratings = 0;
    private string _categories = "";

    public long VideoID
    {
        set { _videoid = value; }
        get { return _videoid; }
    }

    public int isPrivate
    {
        set { _isprivate = value; }
        get { return _isprivate; }
    }

    public int CategoryID
    {
        set { _categoryid = value; }
        get { return _categoryid; }
    }

    public string Title
    {
        set { _title = value; }
        get { return _title; }
    }

    public string Description
    {
        set { _description = value; }
        get { return _description; }
    }

    public string Tags
    {
        set { _tags = value; }
        get { return _tags; }
    }

    public string UserName
    {
        set { _username = value; }
        get { return _username; }
    }

    public int isComments
    {
        set { _iscomments = value; }
        get { return _iscomments; }
    }

    public int isRatings
    {
        set { _isratings = value; }
        get { return _isratings; }
    }

    public int isResponse
    {
        set { _isresponse = value; }
        get { return _isresponse; }
    }

    public string Categories
    {
        set { _categories = value; }
        get { return _categories; }
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {        
        if (!Page.IsPostBack)
        {
            int category_type = 0;
            if (Site_Settings.AllowMultipleCategoryListing)
            {
                // Multiple category selection is on
                CategoriesBLL.BindCategories(l_category, 0, category_type, " " + Resources.vsk.selectcategory + " ", " ", false);
                scat.Visible = false;
            }
            else
            {
                // Single category selection is on
                // load parent / child categories
                CategoriesBLL.BindCategories(drp_category, 0, category_type, " " + Resources.vsk.selectcategory + " ", " ", false);
                mcat.Visible = false;
            }

            LoadInfo();
        }
    }

    private void LoadInfo()
    {
        txt_title.Text = this.Title;
        txt_description.Text = UtilityBLL.DeCompressCodeBreak(this.Description);
        txt_tags.Text = this.Tags;
        if (Site_Settings.Feature_Categories == 1)
        {
            if (Site_Settings.AllowMultipleCategoryListing)
            {
                // multile categories
                UGeneral.SelectMultipleItems(l_category, this.Categories);
            }
            else
            {
                // single category
                drp_category.SelectedValue = this.Categories.ToString();
            }
        }
   
        switch (this.isPrivate)
        {
            case 0:
                r_public.Checked = true;
                break;
            case 1:
                r_private.Checked = true;
                break;
            case 2:
                r_unlisted.Checked = true;
                break;
        }

        if (this.isComments==1)
            r_acmt.Checked = true;
        else
            r_dcmt.Checked = true;

        if (this.isResponse ==1)
            avres.Checked = true;
        else
            dvres.Checked = true;

        if (this.isRatings == 1)
            arat.Checked = true;
        else
            drate.Checked = true;


    }

    protected void btn_update_Click(object sender, EventArgs e)
    {
        Video_Struct vd = new Video_Struct();
        vd.Title = txt_title.Text;
        vd.Description= txt_description.Text;
        vd.Tags = txt_tags.Text;
        vd.VideoID= this.VideoID;
        string _categories = "";
        // categories enabled
        if (Site_Settings.AllowMultipleCategoryListing)
        {
            _categories = UGeneral.ReturnSelectedCategories(l_category);
            if (_categories == "")
            {
                Config.ShowMessageV2(msg, Resources.vsk.selectatleastonecategory, "Error!", 0);
                return;
            }
        }
        else
        {
            _categories = drp_category.SelectedValue;
        }
        vd.Categories = _categories;
        if (avres.Checked)
           vd.isResponse = 1;
        else
            vd.isResponse = 0;
        if (r_acmt.Checked)
            vd.isComments = 1;
        else
            vd.isComments = 0;
        if (arat.Checked)
          vd.isRatings = 1;
        else
            vd.isRatings = 0;

        if (r_private.Checked)
            vd.isPrivate = 1;
        else if (r_unlisted.Checked)
            vd.isPrivate = 2;
        else
            vd.isPrivate = 0;

        VideoBLL.Update_Video_Info(vd);
      
        // Process tags
        int tag_type = 0; // represent videos
        TagsBLL.Process_Tags(txt_tags.Text, tag_type,0);

        Config.ShowMessageV2(msg, Resources.vsk.videoinfoupdate, "Success!", 1); //"Video information updated successfully"
    }
}